## opentimelineio 0.18.1

=== CMakeLists.txt ===
# FindPython's Development.Module component was added in 3.18.
# Require 3.18.2+ because pybind11 recommends it.
cmake_minimum_required(VERSION 3.18.2)

#------------------------------------------------------------------------------
# Project Metadata
# TODO: read this information from a configuration file, here, and in setup.py

set(OTIO_VERSION_MAJOR "0")
set(OTIO_VERSION_MINOR "18")
set(OTIO_VERSION_PATCH "1")
set(OTIO_VERSION ${OTIO_VERSION_MAJOR}.${OTIO_VERSION_MINOR}.${OTIO_VERSION_PATCH})

set(OTIO_AUTHOR       "Contributors to the OpenTimelineIO project")
set(OTIO_AUTHOR_EMAIL "otio-discussion@lists.aswf.io")
set(OTIO_LICENSE      "Modified Apache 2.0 License")

set(CMAKE_OSX_ARCHITECTURES "arm64;x86_64" CACHE STRING "")
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")

project(OpenTimelineIO VERSION ${OTIO_VERSION} LANGUAGES C CXX)

#------------------------------------------------------------------------------
# Options
# Add all options and settings here for all subprojects to aid in project
# maintenance and troubleshooting

# Installation options
option(OTIO_CXX_INSTALL               "Install the C++ bindings" ON)
option(OTIO_PYTHON_INSTALL            "Install the Python bindings" OFF)
option(OTIO_DEPENDENCIES_INSTALL      "Install OTIO's C++ header dependencies (Imath)" ON)
option(OTIO_INSTALL_PYTHON_MODULES    "Install OTIO pure Python modules/files" ON)
option(OTIO_INSTALL_COMMANDLINE_TOOLS "Install the OTIO command line tools" ON)
option(OTIO_FIND_IMATH                "Find Imath using find_package" OFF)
option(OTIO_FIND_RAPIDJSON            "Find RapidJSON using find_package" OFF)
set(OTIO_PYTHON_INSTALL_DIR "" CACHE STRING "Python installation dir (such as the site-packages dir)")

# Build options
#
# If you are building OpenTimelineIO as a static library you will need to
# defined OPENTIME_STATIC and OTIO_STATIC. If you use the provided CMake
# config files these will be automatically defined for you. To use the
# provided config files add `find_package(OpenTimelineIO)` to your
# CMakeLists.txt file.
#
option(OTIO_SHARED_LIBS          "Build shared if ON, static if OFF" ON)
option(OTIO_CXX_COVERAGE         "Invoke code coverage if lcov/gcov is available" OFF)
option(OTIO_CXX_EXAMPLES         "Build CXX examples (also requires OTIO_PYTHON_INSTALL=ON)" OFF)
option(OTIO_AUTOMATIC_SUBMODULES "Fetch submodules automatically" ON)

#------------------------------------------------------------------------------
# Set option dependent variables

if(OTIO_PYTHON_INSTALL)
    # Find the python interpreter using FindPython module.
    # The Development.Module component is used instead of the Development one
    # because we don't need the libpython library since we don't link against it.
    # pybind11 will detect that we already found a python
    # interpreter and will use what was found previously (here).
    # See https://pybind11.readthedocs.io/en/stable/compiling.html#findpython-mode
    # Also, the "manylinux" docker images don't have libpython, so requiring the libraries is an issue there.
    find_package(Python REQUIRED COMPONENTS Interpreter Development.Module)
    message(STATUS "Python_INCLUDE_DIRS: ${Python_INCLUDE_DIRS}")
    message(STATUS "Python_VERSION: ${Python_VERSION}")

    # reconcile install directories for builds incorporating Python in order
    # that default behaviors match a reasonable expectation, as follows:
    #

    # if nothing has been set,
    #   Python: ${Python_SITEARCH}/opentimelineio
    # if only CMAKE_INSTALL_PREFIX has been set,
    #   Python: ${CMAKE_INSTALL_PREFIX}/opentimelineio/python
    # if only OTIO_PYTHON_INSTALL_DIR has been set,
    #   Python: ${OTIO_PYTHON_INSTALL_DIR}/opentimelineio
    #
    # In a Python install, the dylibs/dlls need to be installed where __init__.py
    # can find them, rather as part of the C++ SDK package; so the variable
    # OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR indicates where that is.
    #
    if(OTIO_PYTHON_INSTALL_DIR STREQUAL "" AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        # neither install directory supplied from the command line
        set(OTIO_RESOLVED_PYTHON_INSTALL_DIR "${Python_SITEARCH}")
        set(OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR "${OTIO_RESOLVED_PYTHON_INSTALL_DIR}/opentimelineio")
        message(STATUS "OTIO Defaulting Python install to ${OTIO_RESOLVED_PYTHON_INSTALL_DIR}")
    else()
        # either python_install or install_prefix have been set
        if(NOT OTIO_PYTHON_INSTALL_DIR)
            # CMAKE_INSTALL_PREFIX was set, so install the python components there
            set(OTIO_RESOLVED_PYTHON_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/python")

            # In order to not require setting $PYTHONPATH to point at the .so,
            # the shared libraries are installed into the python library
            # location.
            set(OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR "${OTIO_RESOLVED_PYTHON_INSTALL_DIR}/opentimelineio")
            message(STATUS "OTIO Defaulting Python install to ${OTIO_RESOLVED_PYTHON_INSTALL_DIR}")
        else()
            # OTIO_PYTHON_INSTALL_DIR was set, so install everything into the python package
            set(OTIO_RESOLVED_PYTHON_INSTALL_DIR "${OTIO_PYTHON_INSTALL_DIR}")
            set(OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR "${OTIO_PYTHON_INSTALL_DIR}/opentimelineio")
        endif()
    endif()

    if (WIN32)
        string(REPLACE "\\" "/" OTIO_RESOLVED_PYTHON_INSTALL_DIR ${OTIO_RESOLVED_PYTHON_INSTALL_DIR})
    endif()

else()
    set(OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    message(STATUS "OTIO C++ installing to ${CMAKE_INSTALL_PREFIX}")
endif()

if(OTIO_SHARED_LIBS)
    message(STATUS "Building shared libs")
    set(OTIO_SHARED_OR_STATIC_LIB "SHARED")
else()
    message(STATUS "Building static libs")
    set(OTIO_SHARED_OR_STATIC_LIB "STATIC")
endif()

# Set the SO version. The SO version must be incremented every time a change
# occurs to the ABI that causes a backward incompatibility. Such changes
# include, exhaustively:
#
# * a change to struct or class layout
# * enum changes that would cause a renumbering of previously published enums
# * a removal of a struct, class, enumeration, or function
# * a change in parameters to a free standing function
# * a removal of a global variable
#
# OTIO currently designates the minor version number for breaking changes,
# e.g. v0.15, v0.16.0, v0.17.0, accordingly the SO version will be incremented
# to match. SO version must be monotically increasing, so the ABI version
# should be computed as: major * 100 + revision. The third digit will never
# implicate an ABI version change. So for example, the following OTIO versions
# would map to these ABI versions:
#
# * v0.18.0 - 18
# * v0.19.0 - 19
# * v0.19.1 - 19 # No ABI changes with minor version changes
# * v1.0.0 - 100
# * v1.1.0 - 101
#
math(EXPR OTIO_SOVERSION "${OTIO_VERSION_MAJOR} * 100 + ${OTIO_VERSION_MINOR}")

set(OTIO_RESOLVED_CXX_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}")

if(OTIO_CXX_INSTALL)
    message(STATUS "Installing C++ bindings to: ${OTIO_RESOLVED_CXX_INSTALL_DIR}")
    message(STATUS "Installing C++ dynamic libraries to: ${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}")

    if(OTIO_DEPENDENCIES_INSTALL)
        message(STATUS "  Installing header dependencies for C++ (OTIO_DEPENDENCIES_INSTALL=ON)")
    else()
        message(STATUS "  Not installing header dependencies for C++ (OTIO_DEPENDENCIES_INSTALL=OFF)")
    endif()
else()
    message(STATUS "Install C++ bindings: OFF")
endif()

if(OTIO_PYTHON_INSTALL)
    message(STATUS "Installing Python bindings to: ${OTIO_RESOLVED_PYTHON_INSTALL_DIR}")
else()
    message(STATUS "Install Python bindings: OFF")
endif()

#------------------------------------------------------------------------------
# Global language settings

if (NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(OTIO_CXX_COVERAGE AND NOT MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -fprofile-update=atomic -fprofile-exclude-files='/usr/*;src/deps/*'")
    # this causes cmake to produce file.gcno instead of file.cpp.gcno
    set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE 1)
    message(STATUS "Building C++ with Coverage: ON")
else()
    message(STATUS "Building C++ with Coverage: OFF")
endif()

if(WIN32)
    # Windows debug builds for Python require a d in order for the module to
    # load. This also helps ensure that debug builds in general are matched
    # to the Microsoft debug CRT.
    set(OTIO_DEBUG_POSTFIX "d")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#------------------------------------------------------------------------------
# Fetch or refresh submodules if requested
#
if (OTIO_AUTOMATIC_SUBMODULES)
    # make sure that git submodules are up to date when building
    find_package(Git QUIET)
    if (GIT_FOUND)
        message(STATUS "Checking git repo is available:")
        execute_process(
            # the following command returns true if cwd is in the repo
            COMMAND ${GIT_EXECUTABLE} rev-parse --is-inside-work-tree
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            RESULT_VARIABLE IN_A_GIT_REPO_RETCODE
        )
    endif()

    if (GIT_FOUND AND IN_A_GIT_REPO_RETCODE EQUAL 0)
        # you might want to turn this off if you're working in one of the submodules
        # or trying it out with a different version of the submodule
        option(GIT_UPDATE_SUBMODULES "Update submodules each build" ON)
        if (GIT_UPDATE_SUBMODULES)
            message(
                STATUS "root: Updating git submodules to make sure they are up to date"
            )
            execute_process(
                COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
                RESULT_VARIABLE GIT_UPDATE_SUBMODULES_RESULT
            )
            if (NOT GIT_UPDATE_SUBMODULES_RESULT EQUAL "0")
                message(
                    FATAL_ERROR
                    "git submodule update --init --recursive failed with \
                    ${GIT_UPDATE_SUBMODULES_RESULT}"
                )
            endif()
        endif()
    endif()
endif()

#------------------------------------------------------------------------------
# Setup tests

include(CTest)
set(CTEST_OUTPUT_ON_FAILURE ON)

#------------------------------------------------------------------------------
# Build the dependencies and components

#----- Imath
if(OTIO_FIND_IMATH)
    find_package(Imath REQUIRED)
    if (Imath_FOUND)
        message(STATUS "Found Imath 3 at ${Imath_CONFIG}")
    endif()
else()
    message(STATUS "Using src/deps/Imath by default")
    include_directories("${PROJECT_SOURCE_DIR}/src/deps/Imath/src")
endif()

#----- RapidJSON

if(OTIO_FIND_RAPIDJSON)
    find_package(RapidJSON CONFIG REQUIRED)
    if (RapidJSON_FOUND)
        message(STATUS "Found RapidJSON at ${RapidJSON_CONFIG}")
    endif()
else()
    message(STATUS "Using src/deps/rapidjson by default")
endif()

# set up the internally hosted dependencies
add_subdirectory(src/deps)

add_subdirectory(src/opentime)
add_subdirectory(src/opentimelineio)

if(BUILD_TESTING)
	add_subdirectory(tests)
endif()

if(OTIO_PYTHON_INSTALL)
    add_subdirectory(src/py-opentimelineio)
endif()

if(OTIO_CXX_EXAMPLES)
    add_subdirectory(examples)
endif()

=== Makefile ===
.PHONY: coverage test test_first_fail clean autopep8 lint doc-html \
	python-version wheel manifest lcov lcov-html lcov-reset

# Special definition to handle Make from stripping newlines
define newline


endef

# Color highlighting for the shell
ccred = $(shell echo "\033[0;31m")
ccgreen = $(shell echo "\033[0;32m")
ccblue = $(shell echo "\033[0;34m")
ccend = $(shell echo "\033[0m")

# Helpful link to install development dependencies declared in setup.py
define dev_deps_message
$(ccred)You can install this and other development dependencies with$(newline)$(ccend)\
$(ccblue)	pip install -e .[dev]$(newline)$(ccend)
endef

# variables
MAKE_PROG ?= make

# external programs
COV_PROG := $(shell command -v coverage 2> /dev/null)
LCOV_PROG := $(shell command -v lcov 2> /dev/null)
PYCODESTYLE_PROG := $(shell command -v pycodestyle 2> /dev/null)
PYFLAKES_PROG := $(shell command -v pyflakes 2> /dev/null)
FLAKE8_PROG := $(shell command -v flake8 2> /dev/null)
CHECK_MANIFEST_PROG := $(shell command -v check-manifest 2> /dev/null)
CLANG_FORMAT_PROG := $(shell command -v clang-format 2> /dev/null)
# AUTOPEP8_PROG := $(shell command -v autopep8 2> /dev/null)
TEST_ARGS=

GIT = git
GITSTATUS := $(shell git diff-index --quiet HEAD . 1>&2 2> /dev/null; echo $$?)


ifeq ($(VERBOSE), 1)
	TEST_ARGS:=-v
endif

# Clear the environment of a preset media linker
OTIO_DEFAULT_MEDIA_LINKER =


# run all the unit tests
test: test-core

test-core: python-version
	@echo "$(ccgreen)Running Core tests...$(ccend)"
	@python -m unittest discover -s tests $(TEST_ARGS)

# CI
###################################
ci-prebuild: manifest lint
ci-postbuild: coverage
###################################

python-version:
	@python --version

coverage: coverage-core coverage-report

coverage-report:
	@${COV_PROG} combine .coverage*
	@${COV_PROG} xml
	@${COV_PROG} report -m

# NOTE: coverage configuration is done in setup.cfg

coverage-core: python-version
ifndef COV_PROG
	$(error $(newline)$(ccred) Coverage is not available please see:$(newline)$(ccend)\
	$(ccblue)	https://coverage.readthedocs.io/en/coverage-4.2/install.html $(newline)$(ccend)\
	$(dev_deps_message))
endif
	@${COV_PROG} run -p -m unittest discover tests

lcov:
ifndef LCOV_PROG
	$(error $(newline)$(ccred) lcov is not available please see:$(newline)$(ccend)\
	$(ccblue)	https://github.com/linux-test-project/lcov/blob/master/README $(ccend))
endif
ifneq (OTIO_CXX_COVERAGE_BUILD, 'ON')
	$(warning $(newline)Warning: unless compiled with \
		OTIO_CXX_COVERAGE_BUILD="ON", C++ coverage will not work.)
endif
ifndef OTIO_CXX_BUILD_TMP_DIR
	$(error $(newline)Error: unless compiled with OTIO_CXX_BUILD_TMP_DIR, \
		C++ coverage will not work, because intermediate build products will \
		not be found.)
endif
	lcov --rc lcov_branch_coverage=1 --rc no_exception_branch=1 --ignore-errors mismatch --capture -b . --directory ${OTIO_CXX_BUILD_TMP_DIR} \
		--output-file=${OTIO_CXX_BUILD_TMP_DIR}/coverage.info -q
	cat ${OTIO_CXX_BUILD_TMP_DIR}/coverage.info | sed "s/SF:.*src/SF:src/g" \
		> ${OTIO_CXX_BUILD_TMP_DIR}/coverage.filtered.info
	rm ${OTIO_CXX_BUILD_TMP_DIR}/coverage.info
	lcov --list ${OTIO_CXX_BUILD_TMP_DIR}/coverage.filtered.info


lcov-html: lcov
	@echo -e "$(ccgreen)Generating C++ HTML coverage report...$(ccend)"
	genhtml --quiet --branch-coverage --output-directory lcov_html_report ${OTIO_CXX_BUILD_TMP_DIR}/coverage.filtered.info

lcov-reset:
	@echo "$(tput setaf -Txterm 2)Resetting C++ coverage...$(tput sgr0)"
	lcov -b . --directory ${OTIO_CXX_BUILD_TMP_DIR} --zerocounters

# run all the unit tests, stopping at the first failure
test_first_fail: python-version
	@python -m unittest discover -s tests --failfast

clean:
ifdef COV_PROG
	@${COV_PROG} erase
endif
	rm -vf *.whl
	@cd docs; ${MAKE_PROG} clean

# conform all files to pep8 -- WILL CHANGE FILES IN PLACE
# autopep8:
# ifndef AUTOPEP8_PROG
# 	$(error "autopep8 is not available please see: "\
# 		"https://pypi.python.org/pypi/autopep8#installation")
# endif
# 	find . -name "*.py" | xargs ${AUTOPEP8_PROG} --aggressive --in-place -r

# run the codebase through flake8.  pep8 and pyflakes are called by flake8.
lint:
ifndef PYCODESTYLE_PROG
	$(error $(newline)$(ccred)pycodestyle is not available on $$PATH please see:$(newline)$(ccend)\
	$(ccblue)	https://pypi.python.org/pypi/pep8#installation$(newline)$(ccend)\
	$(dev_deps_message))
endif
ifndef PYFLAKES_PROG
	$(error $(newline)$(ccred)pyflakes is not available on $$PATH please see:$(newline)$(ccend)\
	$(ccblue)	https://pypi.python.org/pypi/pyflakes#installation$(newline)$(ccend)\
	$(dev_deps_message))
endif
ifndef FLAKE8_PROG
	$(error $(newline)$(ccred)flake8 is not available on $$PATH please see:$(newline)$(ccend)\
	$(ccblue)	http://flake8.pycqa.org/en/latest/index.html#installation$(newline)$(ccend)\
	$(dev_deps_message))
endif
	@python -m flake8

# build python wheel package for the available python version
wheel:
	@pip wheel . --no-deps

# format all .h and .cpp files using clang-format
format:
ifndef CLANG_FORMAT_PROG
	$(error $(newline)$(ccred)clang-format is not available on $$PATH$(ccend))
endif
	$(eval DIRS = src/opentime src/opentimelineio)
	$(eval DIRS += src/py-opentimelineio/opentime-opentime-bindings) 
	$(eval DIRS += src/py-opentimelineio/opentimelineio-opentime-bindings)
	$(eval FILES_TO_FORMAT = $(wildcard $(addsuffix /*.h, $(DIRS)) $(addsuffix /*.cpp, $(DIRS))))
	$(shell clang-format -i -style=file $(FILES_TO_FORMAT))

manifest:
ifndef CHECK_MANIFEST_PROG
	$(error $(newline)$(ccred)check-manifest is not available on $$PATH please see:$(newline)$(ccend)\
	$(ccblue)	https://github.com/mgedmin/check-manifest#quick-start$(newline)$(ccend)\
	$(dev_deps_message))
endif
	@check-manifest
	@echo "check-manifest succeeded"
	

doc-model:
	@python src/py-opentimelineio/opentimelineio/console/autogen_serialized_datamodel.py --dryrun

doc-model-update:
	@python src/py-opentimelineio/opentimelineio/console/autogen_serialized_datamodel.py -o docs/tutorials/otio-serialized-schema.md

doc-plugins:
	@python src/py-opentimelineio/opentimelineio/console/autogen_plugin_documentation.py --dryrun

doc-plugins-update:
	@python src/py-opentimelineio/opentimelineio/console/autogen_plugin_documentation.py -o docs/tutorials/otio-plugins.md --public-only --sanitized-paths

# build the CORE_VERSION_MAP cpp file
version-map:
	@python src/py-opentimelineio/opentimelineio/console/autogen_version_map.py -i src/opentimelineio/CORE_VERSION_MAP.last.cpp --dryrun

version-map-update:
	@echo "updating the CORE_VERSION_MAP..."
	@python src/py-opentimelineio/opentimelineio/console/autogen_version_map.py -i src/opentimelineio/CORE_VERSION_MAP.last.cpp -o src/opentimelineio/CORE_VERSION_MAP.cpp

# generate documentation in html
doc-html:
	@# if you just want to build the docs yourself outside of RTD
	@cd docs; ${MAKE_PROG} html

doc-cpp: 
	@cd doxygen ; doxygen config/dox_config ; cd .. 
	@echo "wrote doxygen output to: doxygen/output/html/index.html"
	
# release related targets
confirm-release-intent:
ifndef OTIO_DO_RELEASE
	$(error \
		"If you are sure you want to perform a release, set OTIO_DO_RELEASE=1")
endif
	@echo "Starting release process..."

check-git-status:
ifneq ($(GITSTATUS), 0)
	$(error \
		"Git repository is dirty, cannot create release. Run 'git status' \
		for more info")
endif
	@echo "Git status is clean, ready to proceed with release."

verify-license:
	@echo "Verifying licenses in files..."
	@python maintainers/verify_license.py -s .

fix-license:
	@python maintainers/verify_license.py -s . -f

freeze-ci-versions:
	@echo "freezing CI versions..."
	@python maintainers/freeze_ci_versions.py -f

unfreeze-ci-versions:
	@echo "unfreezing CI versions..."
	@python maintainers/freeze_ci_versions.py -u

# needs to happen _before_ version-map-update so that version in 
# CORE_VERSION_MAP does not have the .dev1 suffix at release time
remove-dev-suffix:
	@echo "Removing .dev1 suffix"
	@python maintainers/remove_dev_suffix.py -r

check-github-token:
ifndef OTIO_RELEASE_GITHUB_TOKEN
	$(error \
		OTIO_RELEASE_GITHUB_TOKEN is not set, unable to update contributors)
endif

update-contributors: check-github-token
	@echo "Updating CONTRIBUTORS.md..."
	@python maintainers/fetch_contributors.py \
		--repo AcademySoftwareFoundation/OpenTimelineIO \
		--token "${OTIO_RELEASE_GITHUB_TOKEN}"

dev-python-install:
	@python setup.py install

# make target for preparing a release candidate 
release: \
	confirm-release-intent \
	check-git-status \
	check-github-token \
	verify-license \
	freeze-ci-versions \
	remove-dev-suffix \
	format \
	dev-python-install \
	version-map-update \
	test-core \
	update-contributors 
	@echo "Release is ready.  Commit, push and open a PR!"

# targets for creating a new version (after making a release, to start the next
# development cycle)
bump-otio-minor-version:
	@python maintainers/bump_version_number.py -i minor

shuffle-core-version-map:
	@cp -f src/opentimelineio/CORE_VERSION_MAP.cpp \
		src/opentimelineio/CORE_VERSION_MAP.last.cpp
	@echo "set the current version map as the next one"

add-dev-suffix:
	@echo "Adding .dev1 suffix"
	@python maintainers/remove_dev_suffix.py -a

# make target for starting a new version (after a release is completed)
start-dev-new-minor-version: \
	check-git-status \
	unfreeze-ci-versions \
	bump-otio-minor-version \
	shuffle-core-version-map \
	add-dev-suffix \
	dev-python-install \
	version-map-update \
	test-core
	@echo "New version made.  Commit, push and open a PR!"

=== docs/requirements.txt ===
sphinx==7.3.7
readthedocs-sphinx-ext==2.1.9 # ??
sphinx-rtd-theme
myst-parser==3.0.1

=== examples/CMakeLists.txt ===
find_package(PythonLibs REQUIRED)

include_directories(${PROJECT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}/../src
    ${PYTHON_INCLUDE_DIRS})

list(APPEND examples conform)
list(APPEND examples flatten_video_tracks)
list(APPEND examples summarize_timing)
list(APPEND examples io_perf_test)
list(APPEND examples upgrade_downgrade_example)
if(OTIO_PYTHON_INSTALL)
    list(APPEND examples python_adapters_child_process)
    list(APPEND examples python_adapters_embed)
endif()
foreach(example ${examples})
    add_executable(${example} ${example}.cpp util.h util.cpp)
    target_link_libraries(${example} OTIO::opentimelineio ${PYTHON_LIBRARIES})
    set_target_properties(${example} PROPERTIES FOLDER examples)
endforeach()

=== tests/CMakeLists.txt ===
include_directories(
    ${PROJECT_SOURCE_DIR}/src
    ${PROJECT_SOURCE_DIR}/src/deps
    ${PROJECT_SOURCE_DIR}/src/deps/optional-lite/include
    ${PROJECT_SOURCE_DIR}/src/tests
    ${CMAKE_BINARY_DIR}/src
)

list(APPEND tests_opentime test_opentime)
foreach(test ${tests_opentime})
	add_executable(${test} utils.h utils.cpp ${test}.cpp)
	target_link_libraries(${test} opentime)
	set_target_properties(${test} PROPERTIES FOLDER tests)
	add_test(NAME ${test} 
           COMMAND ${test}
           # Set the pwd to the source directory so we can load the samples
           # like the python tests do
           WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

list(APPEND tests_opentimelineio test_clip test_serialization test_serializableCollection test_stack_algo test_timeline test_track test_editAlgorithm test_composition)
foreach(test ${tests_opentimelineio})
    add_executable(${test} utils.h utils.cpp ${test}.cpp)

    target_link_libraries(${test} opentimelineio)
    set_target_properties(${test} PROPERTIES FOLDER tests)
    add_test(NAME ${test} 
           COMMAND ${test}
           # Set the pwd to the source directory so we can load the samples
           # like the python tests do
           WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endforeach()

=== src/deps/CMakeLists.txt ===



#----- Other dependencies

# detect if the submodules haven't been updated
set(DEPS_SUBMODULES pybind11)

if(NOT OTIO_FIND_RAPIDJSON)
    set(DEPS_SUBMODULES ${DEPS_SUBMODULES} rapidjson)
endif()

foreach(submodule IN LISTS DEPS_SUBMODULES)
    file(GLOB SUBMOD_CONTENTS ${submodule})
    list(LENGTH SUBMOD_CONTENTS SUBMOD_CONTENT_LEN)
    if(SUBMOD_CONTENT_LEN EQUAL 0)
        message(
            FATAL_ERROR "Error: the submodule ${submodule} is empty.  You may \
            need to install git and run: 'git submodule update' to remedy this."
        )
    endif()
endforeach()

if(OTIO_PYTHON_INSTALL)
    add_subdirectory(pybind11)
endif()

if(NOT OTIO_FIND_IMATH)
    # preserve BUILD_SHARED_LIBS options for this project, but set it off for Imath
    option(BUILD_SHARED_LIBS "Build shared libraries" ON)
    set(BUILD_SHARED_LIBS OFF)

    # If we do not want Imath to install headers and CMake files use the EXCLUDE_FROM_ALL option
    if(OTIO_CXX_INSTALL AND OTIO_DEPENDENCIES_INSTALL)
        add_subdirectory(Imath)
    else()
        add_subdirectory(Imath EXCLUDE_FROM_ALL)
    endif()
endif()

=== src/opentime/CMakeLists.txt ===
#------------------------------------------------------------------------------
# opentime/CMakeLists.txt

set(OPENTIME_HEADER_FILES
    errorStatus.h
    export.h
    rationalTime.h
    stringPrintf.h
    timeRange.h
    timeTransform.h)

add_library(opentime ${OTIO_SHARED_OR_STATIC_LIB} 
            errorStatus.cpp
            rationalTime.cpp
            ${OPENTIME_HEADER_FILES})

add_library(OTIO::opentime ALIAS opentime)

target_include_directories(
    opentime
    PRIVATE
        "${PROJECT_SOURCE_DIR}/src"
        "${CMAKE_CURRENT_BINARY_DIR}/.."
)

set_target_properties(opentime PROPERTIES 
    DEBUG_POSTFIX "${OTIO_DEBUG_POSTFIX}"
    LIBRARY_OUTPUT_NAME "opentime"
    POSITION_INDEPENDENT_CODE TRUE)

if(OTIO_SHARED_LIBS)
    set_target_properties(opentime PROPERTIES
        SOVERSION ${OTIO_SOVERSION}
        VERSION ${OTIO_VERSION})
    target_compile_definitions(
        opentime
        PUBLIC
        OPENTIME_EXPORTS)
else()
    target_compile_definitions(
        opentime
        PUBLIC
        OPENTIME_STATIC)
endif()

if(APPLE)
    set_target_properties(opentime PROPERTIES 
        INSTALL_NAME_DIR "@loader_path"
        MACOSX_RPATH ON)
endif()

target_compile_options(opentime PRIVATE
     $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
     -Wall>
     $<$<CXX_COMPILER_ID:MSVC>: /W4>
     $<$<CXX_COMPILER_ID:MSVC>: /EHsc>
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
)

if(OTIO_CXX_INSTALL)
    install(FILES ${OPENTIME_HEADER_FILES} 
            DESTINATION "${OTIO_RESOLVED_CXX_INSTALL_DIR}/include/opentime")

    install(TARGETS opentime
            EXPORT OpenTimeTargets
            INCLUDES DESTINATION "${OTIO_RESOLVED_CXX_INSTALL_DIR}/include"
            ARCHIVE DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
            LIBRARY DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
            RUNTIME DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}")

    install(EXPORT OpenTimeTargets
            DESTINATION "${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentime"
            NAMESPACE OTIO:: )

    include(CMakePackageConfigHelpers)
    configure_package_config_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/OpenTimeConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/OpenTimeConfig.cmake
        INSTALL_DESTINATION
            ${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentime
        NO_SET_AND_CHECK_MACRO
        NO_CHECK_REQUIRED_COMPONENTS_MACRO
    )

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/OpenTimeConfig.cmake
        DESTINATION
            ${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentime
    )

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/version.h
        DESTINATION
            "${OTIO_RESOLVED_CXX_INSTALL_DIR}/include/opentime"
    )
endif()

=== src/opentimelineio/CMakeLists.txt ===
#------------------------------------------------------------------------------
# opentimelineio/CMakeLists.txt

set(OPENTIMELINEIO_HEADER_FILES
    anyDictionary.h
    anyVector.h
    color.h
    clip.h
    composable.h
    composition.h
    deserialization.h
    algo/editAlgorithm.h
    effect.h
    errorStatus.h
    export.h
    externalReference.h
    freezeFrame.h
    gap.h
    generatorReference.h
    imageSequenceReference.h
    item.h
    linearTimeWarp.h
    marker.h
    mediaReference.h
    missingReference.h
    safely_typed_any.h
    serializableCollection.h
    serializableObject.h
    serializableObjectWithMetadata.h
    serialization.h
    stack.h
    stackAlgorithm.h
    timeEffect.h
    timeline.h
    track.h
    trackAlgorithm.h
    transition.h
    typeRegistry.h
    unknownSchema.h
    vectorIndexing.h)

add_library(opentimelineio ${OTIO_SHARED_OR_STATIC_LIB}
    color.cpp
    clip.cpp
    composable.cpp
    composition.cpp
    deserialization.cpp
    algo/editAlgorithm.cpp
    effect.cpp
    errorStatus.cpp
    externalReference.cpp
    freezeFrame.cpp
    gap.cpp
    generatorReference.cpp
    imageSequenceReference.cpp
    item.cpp
    linearTimeWarp.cpp
    marker.cpp
    mediaReference.cpp
    missingReference.cpp
    safely_typed_any.cpp
    serializableCollection.cpp
    serializableObject.cpp
    serializableObjectWithMetadata.cpp
    serialization.cpp
    stack.cpp
    stackAlgorithm.cpp
    stringUtils.cpp
    stringUtils.h # stringUtils.h is a private header
    timeEffect.cpp
    timeline.cpp
    track.cpp
    trackAlgorithm.cpp
    transition.cpp
    typeRegistry.cpp
    unknownSchema.cpp 
    CORE_VERSION_MAP.cpp
    ${OPENTIMELINEIO_HEADER_FILES})

add_library(OTIO::opentimelineio ALIAS opentimelineio)

target_include_directories(
    opentimelineio
    PRIVATE
        "${PROJECT_SOURCE_DIR}/src"
        "${CMAKE_CURRENT_BINARY_DIR}/.."
)

if(OTIO_FIND_RAPIDJSON)
    target_include_directories(opentimelineio
        PRIVATE "${RapidJSON_INCLUDE_DIRS}")
else()
    target_include_directories(opentimelineio
        PRIVATE "${PROJECT_SOURCE_DIR}/src/deps/rapidjson/include")
endif()


target_link_libraries(opentimelineio 
    PUBLIC opentime Imath::Imath)

set_target_properties(opentimelineio PROPERTIES
    DEBUG_POSTFIX "${OTIO_DEBUG_POSTFIX}"
    LIBRARY_OUTPUT_NAME "opentimelineio"
    POSITION_INDEPENDENT_CODE TRUE)

if(OTIO_SHARED_LIBS)
    set_target_properties(opentimelineio PROPERTIES
        SOVERSION ${OTIO_SOVERSION}
        VERSION ${OTIO_VERSION})
    target_compile_definitions(
        opentimelineio
        PUBLIC
        OTIO_EXPORTS)
else()
    target_compile_definitions(
        opentimelineio
        PUBLIC
        OTIO_STATIC)
endif()

if(APPLE)
    set_target_properties(opentimelineio PROPERTIES 
        INSTALL_NAME_DIR "@loader_path"
        MACOSX_RPATH ON)
endif()

# override any global CXX_FLAGS settings that came from dependencies
target_compile_options(opentimelineio PRIVATE
     $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
     -Wall>
     $<$<CXX_COMPILER_ID:MSVC>: /W4>
     $<$<CXX_COMPILER_ID:MSVC>: /EHsc>
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
)

if(OTIO_CXX_INSTALL)
    install(FILES ${OPENTIMELINEIO_HEADER_FILES} 
            DESTINATION "${OTIO_RESOLVED_CXX_INSTALL_DIR}/include/opentimelineio")

    set(OPENTIMELINEIO_INCLUDES ${OTIO_RESOLVED_CXX_INSTALL_DIR}/include)

    install(TARGETS opentimelineio
           EXPORT OpenTimelineIOTargets
           INCLUDES DESTINATION "${OPENTIMELINEIO_INCLUDES}"
           ARCHIVE DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
           LIBRARY DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
           RUNTIME DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}")

    install(EXPORT OpenTimelineIOTargets
           DESTINATION "${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentimelineio"
           NAMESPACE OTIO:: )

    include(CMakePackageConfigHelpers)
    configure_package_config_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/OpenTimelineIOConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/OpenTimelineIOConfig.cmake
        INSTALL_DESTINATION
            ${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentimelineio
        NO_SET_AND_CHECK_MACRO
        NO_CHECK_REQUIRED_COMPONENTS_MACRO
    )

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/OpenTimelineIOConfig.cmake
        DESTINATION
            ${OTIO_RESOLVED_CXX_INSTALL_DIR}/share/opentimelineio
    )

    install(
        FILES
            ${CMAKE_CURRENT_BINARY_DIR}/version.h
        DESTINATION
            "${OTIO_RESOLVED_CXX_INSTALL_DIR}/include/opentimelineio"
    )
endif()

=== src/py-opentimelineio/CMakeLists.txt ===
#------------------------------------------------------------------------------
# py-opentimelineio/CMakeLists.txt

add_subdirectory(opentime-bindings)
add_subdirectory(opentimelineio-bindings)

if(OTIO_INSTALL_PYTHON_MODULES)
    # Install pure-python OTIO packages to match PyPI wheel structure
    install(DIRECTORY "${PROJECT_SOURCE_DIR}/src/py-opentimelineio/opentimelineio/"
        DESTINATION "${OTIO_RESOLVED_PYTHON_INSTALL_DIR}/opentimelineio")

endif()

=== src/py-opentimelineio/opentime-bindings/CMakeLists.txt ===
#------------------------------------------------------------------------------
# py-opentimelineio/opentime-bindings/CMakeLists.txt

pybind11_add_module(_opentime
                    opentime_bindings.cpp
                    opentime_rationalTime.cpp
                    opentime_timeRange.cpp
                    opentime_timeTransform.cpp
                    opentime_bindings.h)

target_include_directories(_opentime 
    PRIVATE pybind11/include
    PRIVATE "${PROJECT_SOURCE_DIR}/src"
    PRIVATE "${PROJECT_SOURCE_DIR}/src/deps"
    PRIVATE "${PROJECT_SOURCE_DIR}/src/deps/optional-lite/include"
    PRIVATE "${CMAKE_BINARY_DIR}/src"
)

target_link_libraries(_opentime PUBLIC opentimelineio opentime)

set_target_properties(_opentime PROPERTIES
    LIBRARY_OUTPUT_NAME "_opentime"
    DEBUG_POSTFIX "${OTIO_DEBUG_POSTFIX}")

# The version of pybind11 we are currently using generates an overwhelming number of
# compiler warnings; until we update pybind11, suprress the warnings:
target_compile_options(_opentime PRIVATE
    $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
        -Wno-range-loop-analysis>
    $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
        -Wno-unused-value>
    $<$<CXX_COMPILER_ID:MSVC>: /EHsc>
)

if(APPLE)
    set_target_properties(_opentime PROPERTIES 
        INSTALL_NAME_DIR "@loader_path"
        MACOSX_RPATH ON)
elseif(UNIX)
    set_target_properties(_opentime PROPERTIES 
        INSTALL_RPATH "$ORIGIN"
        INSTALL_RPATH_USE_LINK_PATH OFF)
endif()

install(TARGETS _opentime
        ARCHIVE DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
        LIBRARY DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
        RUNTIME DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}")

=== src/py-opentimelineio/opentimelineio-bindings/CMakeLists.txt ===
#------------------------------------------------------------------------------
# py-opentimelineio/opentimelineio-bindings/CMakeLists.txt

set(_OTIO_HEADER_FILES
    otio_errorStatusHandler.h
    otio_anyDictionary.h
    otio_bindings.h
    otio_utils.h)

pybind11_add_module(_otio
                    otio_errorStatusHandler.cpp
                    otio_anyDictionary.cpp
                    otio_anyVector.cpp
                    otio_bindings.cpp
                    otio_imath.cpp
                    otio_tests.cpp
                    otio_serializableObjects.cpp
                    otio_utils.cpp 
                    ${_OTIO_HEADER_FILES})

target_include_directories(_otio 
    PRIVATE pybind11/include
    PRIVATE "${PROJECT_SOURCE_DIR}/src"
    PRIVATE "${PROJECT_SOURCE_DIR}/src/deps"
    PRIVATE "${PROJECT_SOURCE_DIR}/src/deps/optional-lite/include"
    PRIVATE "${CMAKE_BINARY_DIR}/src"
)

target_link_libraries(_otio PUBLIC opentimelineio opentime)

# The version of pybind11 we are currently using generates an overwhelming number of
# compiler warnings; until we update pybind11, suprress the warnings:
target_compile_options(_otio PRIVATE
     $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
     -Wno-range-loop-analysis>
     $<$<OR:$<CXX_COMPILER_ID:Clang>,$<CXX_COMPILER_ID:AppleClang>,$<CXX_COMPILER_ID:GNU>>:
     -Wno-unused-value>
     $<$<CXX_COMPILER_ID:MSVC>: /EHsc>
)

set_target_properties(_otio PROPERTIES
    LIBRARY_OUTPUT_NAME "_otio"
    DEBUG_POSTFIX "${OTIO_DEBUG_POSTFIX}")

if(APPLE)
    set_target_properties(_otio PROPERTIES 
        INSTALL_NAME_DIR "@loader_path"
        MACOSX_RPATH ON)
elseif(UNIX)
    set_target_properties(_otio PROPERTIES 
        INSTALL_RPATH "$ORIGIN"
        INSTALL_RPATH_USE_LINK_PATH OFF)
endif()

install(TARGETS _otio 
        ARCHIVE DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
        LIBRARY DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}"
        RUNTIME DESTINATION "${OTIO_RESOLVED_CXX_DYLIB_INSTALL_DIR}")

=== debian/changelog ===
opentimelineio (0.18.1-1fakesync1) resolute; urgency=medium

  * Fake sync due to mismatching orig tarball.

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 27 Nov 2025 12:25:49 -0500

opentimelineio (0.18.1-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patch 02-cmake-fixes.
  * Add missing files.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 27 Nov 2025 10:36:59 +0100

=== debian/control ===
Source: opentimelineio
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Homepage: https://github.com/AcademySoftwareFoundation/OpenTimelineIO
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
 cmake,
 libimath-dev

Package: libopentimelineio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libopentimelineio0 (= ${binary:Version})
Description: API for editorial cut information - development files
 An interchange format and API for editorial cut information. OTIO contains
 information about the order and length of cuts and references to external
 media.  It is not however, a container format for media.
 .
 For integration with applications, the core OTIO library is implemented in
 C++ and provides an in-memory data model, as well as library functions for
 interpreting, manipulating, and serializing that data model.
 .
 The project also supports an official Python binding, which is intended to
 be an idiomatic and ergonomic binding for Python developers. The Python
 binding includes a plugin system which supports a number of different types
 of plugins, most notably adapters, which can be used to read and write
 legacy formats into the OTIO data model.
 .
 This package contains the development files for the library.

Package: libopentimelineio0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: API for editorial cut information
 An interchange format and API for editorial cut information. OTIO contains
 information about the order and length of cuts and references to external
 media.  It is not however, a container format for media.
 .
 For integration with applications, the core OTIO library is implemented in
 C++ and provides an in-memory data model, as well as library functions for
 interpreting, manipulating, and serializing that data model.
 .
 The project also supports an official Python binding, which is intended to
 be an idiomatic and ergonomic binding for Python developers. The Python
 binding includes a plugin system which supports a number of different types
 of plugins, most notably adapters, which can be used to read and write
 legacy formats into the OTIO data model.
